-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.InitCleave = function()	
	cfg.Cleave={}
	cfg.Cleave["none"]={}
	cfg.Cleave["none"].threshold=cfg.cleave_threshold
	cfg.Cleave["none"].cast_time=0
	cfg.Cleave["none"].hit_time=0
	cfg.Cleave["none"].num=0
	cfg.Cleave["none"].targets={}
	cfg.cleave_current="none"
end

lib.AddCleave = function(spell,threshold,spellid2,cast_id) --,noreset)
	if not cfg.spells[spell] then return end
	if not cfg.Cleave then
		lib.InitCleave()
	end
	cfg.Cleave[spell]=cfg.Cleave[spell] or {}
	cfg.Cleave[spell].threshold=threshold or cfg.cleave_threshold
	cfg.cleave_threshold=cfg.Cleave[spell].threshold
	cfg.Cleave[spell].cast_time=0
	cfg.Cleave[spell].hit_time=0
	cfg.Cleave[spell].num=0
	cfg.Cleave[spell].targets={}
	--cfg.Cleave[spell].noreset=noreset

	cfg.Id2Cleave[cfg.spells[spell].id]=spell
	if spellid2 then
		if type(spellid2)=="number" then
			cfg.Id2Cleave[spellid2]=spell
		else
			for index,id in ipairs(spellid2) do
				cfg.Id2Cleave[id]=spell
			end
		end
	end
	if cast_id then
		cfg.Id2Cleave[cast_id]=spell
	end
	--[[if not cfg.CleaveAdder then return end
	for _,id in pairs(cfg.CleaveAdder) do
		cfg.Id2Cleave[id]=spell
	end]]
	
	--cfg.Id2Cleave[cfg.Cleave[spell].id]=spell
	--cfg.Id2Cleave[cfg.Cleave[spell].id2]=spell
end

--[[lib.AddCleaveAdder = function(spell,spellid2)
	if not cfg.spells[spell] then return end
	cfg.CleaveAdder=cfg.CleaveAdder or {}
	cfg.CleaveAdder[cfg.spells[spell].id]=true
	lib.AddCleave(spell,nil,spellid2,nil,true)
end]]

lib.ResetCleaveAll = function()
	if cfg.Cleave then
		for spell,_ in pairs(cfg.Cleave) do
			lib.ResetCleave(spell)
		end
		lib.UpdateCleave(0)
		cfg.cleave_current="none"
	end
end
lib.ResetCleave=function(cleaveID,timeStamp)
	--print(type(cleaveID))
	if cfg.Cleave then
		if type(cleaveID)=="number" then
			cleaveID=cfg.Id2Cleave[cleaveID] or "none"
		end
		if cfg.Cleave[cleaveID] and not cfg.Cleave[cleaveID].noreset then
			--print("Reseting Cleave "..cleaveID)
			timeStamp = timeStamp or time()
			if cfg.Cleave[cleaveID].cast_time<timeStamp then
				cfg.Cleave[cleaveID].cast_time = timeStamp
				if cfg.Cleave[cleaveID].cast_time>cfg.Cleave[cleaveID].hit_time then
					cfg.Cleave[cleaveID].targets={}
					cfg.Cleave[cleaveID].num=0
					if cfg.Cleave[cleaveID].text then cfg.Cleave[cleaveID].text:SetText("") end
					--lib.UpdateCleave(0)
				end
			end
		end	
	end
end

lib.AddCleaveTarget = function(cleaveID,destGUID,timeStamp)
	--print(cleaveID.." "..destGUID.." "..timeStamp)
	if cfg.Cleave then
		cleaveID=cleaveID or cfg.cleave_current
		--cfg.cleave_current=cfg.cleave_current
		if type(cleaveID)=="number" then
			cfg.cleave_current=cfg.Id2Cleave[cleaveID] or cfg.cleave_current --"none"
		else
			cfg.cleave_current=cleaveID
		end
		if cfg.Cleave[cfg.cleave_current] then
			timeStamp = timeStamp or time()
			if not cfg.Cleave[cfg.cleave_current].targets[destGUID] then
				cfg.Cleave[cfg.cleave_current].targets[destGUID]=lib.AddNPC(destGUID)
				cfg.Cleave[cfg.cleave_current].num = cfg.Cleave[cfg.cleave_current].num + 1
				if cfg.Cleave[cfg.cleave_current].text then cfg.Cleave[cfg.cleave_current].text:SetText(cfg.Cleave[cfg.cleave_current].num>0 and cfg.Cleave[cfg.cleave_current].num or "") end
				lib.UpdateCleave(cfg.Cleave[cfg.cleave_current].num)
			end
		end	
	end
end

lib.UpdateCleave=function(targets)
	if cfg.cleave_targets~=targets then
		cfg.cleave_targets=targets
		if cfg.cleave_targets>1 then
			Heddmain.spells.cleave:SetText(cfg.cleave_targets)
			if cfg.cleave_targets>=cfg.cleave_threshold then
				Heddmain.spells.cleave:SetTextColor(1,0,0,1)
			else
				Heddmain.spells.cleave:SetTextColor(1,1,1,1)
			end
		else
			Heddmain.spells.cleave:SetText("")
		end
		cfg.Update=true
	end
end